package it.eng.urbanite.dashboard.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import it.eng.urbanite.dashboard.model.enumeration.TargetType;

/**
 * The TargetAvailable entity.
 */
@Entity
@Table(name = "target_available")
public class TargetAvailable extends AbstractAuditingEntity implements Serializable {
    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "sequenceGenerator")
    @SequenceGenerator(name = "sequenceGenerator")
    private Long id;

    @NotNull
    @Enumerated(EnumType.STRING)
    @Column(name = "type", nullable = false)
    private TargetType type;

    @NotNull
    @Column(name = "code", nullable = false)
    private String code;

    @NotNull
    @Column(name = "value", nullable = false)
    private String value;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public TargetAvailable id(Long id) {
        this.id = id;
        return this;
    }

    public TargetType getType() {
        return this.type;
    }

    public TargetAvailable type(TargetType type) {
        this.type = type;
        return this;
    }

    public void setType(TargetType type) {
        this.type = type;
    }

    public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getValue() {
		return value;
	}

	public void setValue(String value) {
		this.value = value;
	}

	public TargetAvailable value(String value) {
        this.value = value;
        return this;
    }

    public TargetAvailable code(String code) {
        this.code = code;
        return this;
    }


    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof TargetAvailable)) {
            return false;
        }
        return id != null && id.equals(((TargetAvailable) o).id);
    }

    @Override
    public int hashCode() {
        return getClass().hashCode();
    }

    @Override
    public String toString() {
        return "Target{" +
            "id=" + getId() +
            ", type='" + getType() + "'" +
            ", code='" + getCode() + "'" +
            ", value='" + getValue() + "'" +
            "}";
    }
}
