package it.eng.urbanite.dashboard.model.enumeration;

import java.util.Arrays;
import java.util.List;

import lombok.Getter;

/**
 * The TargetType enumeration.
 */
public enum CloningOpionType {
	NONE 			("NONE"),
	TARGETS 		("TARGETS"),
	MENU 			("MENU"),
	COMPONENTS 		("COMPONENTS"),
	ALL 			("ALL");

	@Getter private String code;


	/**
	 * Constructor 
	 * @param code String
	 */
	private CloningOpionType(String code) {
		this.code = code;
	}


	/**
	 * @param code code
	 * @return Topics
	 */
	public static CloningOpionType forCode(String code) {
		try {
			return CloningOpionType.valueOf(code);
		} catch (IllegalArgumentException e) {
			throw new RuntimeException("Invalid value for enumeration " + CloningOpionType.class.getSimpleName() + " : " + code);
		}
	}

	/**
	 * @return List<TargetType>
	 */
	public static List<CloningOpionType> getValues() {
		return Arrays.asList(CloningOpionType.values());
	}

}

