package it.eng.urbanite.dashboard.model.enumeration;

import java.util.Arrays;
import java.util.List;

import lombok.Getter;

/**
 * The TargetType enumeration.
 */
public enum TargetType {
	PERSON 	("PERSON"),
	GROUP	("GROUP"),
	PUBLIC ("PUBLIC"),
	ROLE   ("ROLE");

	@Getter private String code;


	/**
	 * Constructor 
	 * @param code String
	 */
	private TargetType(String code) {
		this.code = code;
	}


	/**
	 * @param code code
	 * @return Topics
	 */
	public static TargetType forCode(String code) {
		try {
			return TargetType.valueOf(code);
		} catch (IllegalArgumentException e) {
			throw new RuntimeException("Invalid value for enumeration " + TargetType.class.getSimpleName() + " : " + code);
		}
	}

	/**
	 * @return List<TargetType>
	 */
	public static List<TargetType> getValues() {
		return Arrays.asList(TargetType.values());
	}

}

