package it.eng.urbanite.dashboard.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import it.eng.urbanite.dashboard.model.TargetAvailable;
import it.eng.urbanite.dashboard.model.enumeration.TargetType;

/**
 * Spring Data SQL repository for the TargetAvailable entity.
 */
@SuppressWarnings("unused")
@Repository
public interface TargetAvailableRepository extends JpaRepository<TargetAvailable, Long>, JpaSpecificationExecutor<TargetAvailable> {
	
	/**
	 * Return list of TargetAvailable filtered by TargetType 
	 * 
	 * @param type TargetType
	 * @return List of TargetAvailable
	 */
	List<TargetAvailable> findByType(TargetType type);
}
