package it.eng.urbanite.dashboard.service;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import it.eng.urbanite.dashboard.service.dto.DashboardComponentDTO;

/**
 * Service Interface for managing {@link it.eng.urbanite.dashboard.domain.DashboardComponent}.
 */
public interface DashboardComponentService {
    /**
     * Save a dashboardComponent.
     *
     * @param dashboardComponentDTO the entity to save.
     * @return the persisted entity.
     */
    DashboardComponentDTO save(DashboardComponentDTO dashboardComponentDTO);

    /**
     * Get all the dashboardComponents.
     *
     * @param pageable the pagination information.
     * @return the list of entities.
     */
    Page<DashboardComponentDTO> findAll(Pageable pageable);

    /**
     * Get all the dashboardComponents.
     *
     * @return the list of entities.
     */
    List<DashboardComponentDTO> findAll();

    /**
     * Get the "id" dashboardComponent.
     *
     * @param id the id of the entity.
     * @return the entity.
     */
    Optional<DashboardComponentDTO> findOne(Long id);

    /**
     * Delete the "id" dashboardComponent.
     *
     * @param id the id of the entity.
     */
    void delete(Long id);
}
