package it.eng.urbanite.dashboard.service;

import java.util.List;
import java.util.Optional;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import it.eng.urbanite.dashboard.model.enumeration.TargetType;
import it.eng.urbanite.dashboard.service.dto.TargetAvailableDTO;

/**
 * Service Interface for managing {@link it.eng.urbanite.dashboard.domain.TargetAvailable}.
 */
public interface TargetAvailableService {
    /**
     * Save a TargetAvailable.
     *
     * @param targetDTO the entity to save.
     * @return the persisted entity.
     */
	TargetAvailableDTO save(TargetAvailableDTO targetDTO);

    /**
     * Get all the TargetAvailables.
     *
     * @param pageable the pagination information.
     * @return the list of entities.
     */
    Page<TargetAvailableDTO> findAll(Pageable pageable);

    /**
     * Get all the TargetAvailables.
     *
     * @return the list of entities.
     */
    List<TargetAvailableDTO> findAll();

    /**
     * Get all the TargetAvailables by type.
     *
     * @param type the pagination information.
     * @return the list of entities.
     */
    List<TargetAvailableDTO> findByType(TargetType type);

    /**
     * Get the "id" TargetAvailable.
     *
     * @param id the id of the entity.
     * @return the entity.
     */
    Optional<TargetAvailableDTO> findOne(Long id);

    /**
     * Delete the "id" TargetAvailable.
     *
     * @param id the id of the entity.
     */
    void delete(Long id);
}
