package it.eng.urbanite.dashboard.service.criteria;

import java.io.Serializable;
import java.util.Objects;

import it.eng.urbanite.dashboard.model.enumeration.ComponentType;
import tech.jhipster.service.Criteria;
import tech.jhipster.service.filter.Filter;
import tech.jhipster.service.filter.InstantFilter;
import tech.jhipster.service.filter.LongFilter;
import tech.jhipster.service.filter.StringFilter;

public class DashboardComponentCriteria implements Serializable, Criteria {

    /**
     * Class for filtering ComponentType
     */
    public static class ComponentTypeFilter extends Filter<ComponentType> {

        /**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public ComponentTypeFilter() {}

        public ComponentTypeFilter(ComponentTypeFilter filter) {
            super(filter);
        }

        @Override
        public ComponentTypeFilter copy() {
            return new ComponentTypeFilter(this);
        }
    }

    private static final long serialVersionUID = 1L;

    private LongFilter id;
    private ComponentTypeFilter componentType;
    private StringFilter componentName;
    private StringFilter componentcontent;
    private StringFilter componentPosition;
    private InstantFilter createdDate;
    private StringFilter createdBy;
    private LongFilter dashboardPageId;
    
    public DashboardComponentCriteria() {}

    public DashboardComponentCriteria(DashboardComponentCriteria other) {
        this.id = other.id == null ? null : other.id.copy();
        this.componentType = other.componentType == null ? null : other.componentType.copy();
        this.componentName = other.componentName == null ? null : other.componentName.copy();
        this.componentcontent = other.componentcontent == null ? null : other.componentcontent.copy();
        this.componentPosition = other.componentPosition == null ? null : other.componentPosition.copy();
        this.createdDate = other.createdDate == null ? null : other.createdDate.copy();
        this.createdBy = other.createdBy == null ? null : other.createdBy.copy();
        this.dashboardPageId = other.dashboardPageId == null ? null : other.dashboardPageId.copy();
    }

    @Override
    public DashboardComponentCriteria copy() {
        return new DashboardComponentCriteria(this);
    }

    public LongFilter getId() {
        return id;
    }

    public LongFilter id() {
        if (id == null) {
            id = new LongFilter();
        }
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public ComponentTypeFilter getComponentType() {
        return componentType;
    }

    public ComponentTypeFilter componentType() {
        if (componentType == null) {
            componentType = new ComponentTypeFilter();
        }
        return componentType;
    }

    public void setComponentType(ComponentTypeFilter componentType) {
        this.componentType = componentType;
    }

    public StringFilter getComponentName() {
        return componentName;
    }

    public StringFilter componentName() {
        if (componentName == null) {
            componentName = new StringFilter();
        }
        return componentName;
    }

    public void setComponentName(StringFilter componentName) {
        this.componentName = componentName;
    }

    public StringFilter getComponentcontent() {
        return componentcontent;
    }

    public StringFilter componentcontent() {
        if (componentcontent == null) {
            componentcontent = new StringFilter();
        }
        return componentcontent;
    }

    public void setComponentcontent(StringFilter componentcontent) {
        this.componentcontent = componentcontent;
    }

    public StringFilter getComponentPosition() {
        return componentPosition;
    }

    public StringFilter componentPosition() {
        if (componentPosition == null) {
            componentPosition = new StringFilter();
        }
        return componentPosition;
    }

    public void setComponentPosition(StringFilter componentPosition) {
        this.componentPosition = componentPosition;
    }

    public InstantFilter getCreatedDate() {
        return createdDate;
    }

    public InstantFilter createdDate() {
        if (createdDate == null) {
            createdDate = new InstantFilter();
        }
        return createdDate;
    }

    public void setCreatedDate(InstantFilter createdDate) {
        this.createdDate = createdDate;
    }

    public StringFilter getCreatedBy() {
        return createdBy;
    }

    public StringFilter createdBy() {
        if (createdBy == null) {
            createdBy = new StringFilter();
        }
        return createdBy;
    }

    public void setCreatedBy(StringFilter createdBy) {
        this.createdBy = createdBy;
    }

    public LongFilter getDashboardPageId() {
        return dashboardPageId;
    }

    public LongFilter dashboardPageId() {
        if (dashboardPageId == null) {
            dashboardPageId = new LongFilter();
        }
        return dashboardPageId;
    }

    public void setDashboardPageId(LongFilter dashboardPageId) {
        this.dashboardPageId = dashboardPageId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final DashboardComponentCriteria that = (DashboardComponentCriteria) o;
        return (
            Objects.equals(id, that.id) &&
            Objects.equals(componentType, that.componentType) &&
            Objects.equals(componentName, that.componentName) &&
            Objects.equals(componentcontent, that.componentcontent) &&
            Objects.equals(componentPosition, that.componentPosition) &&
            Objects.equals(createdDate, that.createdDate) &&
            Objects.equals(createdBy, that.createdBy) &&
            Objects.equals(dashboardPageId, that.dashboardPageId)
        );
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, componentType, componentName, componentcontent, componentPosition, createdDate, createdBy, dashboardPageId);
    }

    @Override
    public String toString() {
        return "DashboardComponentCriteria{" +
            (id != null ? "id=" + id + ", " : "") +
            (componentType != null ? "componentType=" + componentType + ", " : "") +
            (componentName != null ? "componentName=" + componentName + ", " : "") +
            (componentcontent != null ? "componentcontent=" + componentcontent + ", " : "") +
            (componentPosition != null ? "componentPosition=" + componentPosition + ", " : "") +
            (createdDate != null ? "createdDate=" + createdDate + ", " : "") +
            (createdBy != null ? "createdBy=" + createdBy + ", " : "") +
            (dashboardPageId != null ? "dashboardPageId=" + dashboardPageId + ", " : "") +
            "}";
    }
}
