package it.eng.urbanite.dashboard.service.criteria;

import java.io.Serializable;
import java.util.Objects;

import tech.jhipster.service.Criteria;
import tech.jhipster.service.filter.BooleanFilter;
import tech.jhipster.service.filter.InstantFilter;
import tech.jhipster.service.filter.LongFilter;
import tech.jhipster.service.filter.StringFilter;

public class DashboardPageCriteria implements Serializable, Criteria {
    private static final long serialVersionUID = 1L;
    
    private LongFilter id;
    private StringFilter name;
    private StringFilter description;
    private StringFilter content;
    private StringFilter note;
    private BooleanFilter shared;
    private InstantFilter createdDate;
    private StringFilter createdBy;
    private LongFilter dashboardComponentId;
    private LongFilter targetId;
    private BooleanFilter myPages;

    public DashboardPageCriteria() {}

    public DashboardPageCriteria(DashboardPageCriteria other) {
        this.id = other.id == null ? null : other.id.copy();
        this.name = other.name == null ? null : other.name.copy();
        this.description = other.description == null ? null : other.description.copy();
        this.content = other.content == null ? null : other.content.copy();
        this.note = other.note == null ? null : other.note.copy();
        this.shared = other.shared == null ? null : other.shared.copy();
        this.createdDate = other.createdDate == null ? null : other.createdDate.copy();
        this.createdBy = other.createdBy == null ? null : other.createdBy.copy();
        this.dashboardComponentId = other.dashboardComponentId == null ? null : other.dashboardComponentId.copy();
        this.targetId = other.targetId == null ? null : other.targetId.copy();
        this.myPages = other.myPages == null ? null : other.myPages.copy();
    }

    @Override
    public DashboardPageCriteria copy() {
        return new DashboardPageCriteria(this);
    }

    public LongFilter getId() {
        return id;
    }

    public LongFilter id() {
        if (id == null) {
            id = new LongFilter();
        }
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public StringFilter getName() {
        return name;
    }

    public StringFilter name() {
        if (name == null) {
            name = new StringFilter();
        }
        return name;
    }

    public void setName(StringFilter name) {
        this.name = name;
    }

    public StringFilter getDescription() {
        return description;
    }

    public StringFilter description() {
        if (description == null) {
            description = new StringFilter();
        }
        return description;
    }

    public void setDescription(StringFilter description) {
        this.description = description;
    }

    public StringFilter getContent() {
        return content;
    }

    public StringFilter content() {
        if (content == null) {
            content = new StringFilter();
        }
        return content;
    }

    public void setContent(StringFilter content) {
        this.content = content;
    }

    public StringFilter getNote() {
        return note;
    }

    public StringFilter note() {
        if (note == null) {
            note = new StringFilter();
        }
        return note;
    }

    public void setNote(StringFilter note) {
        this.note = note;
    }

    public BooleanFilter getShared() {
        return shared;
    }

    public BooleanFilter shared() {
        if (shared == null) {
            shared = new BooleanFilter();
        }
        return shared;
    }

    public void setShared(BooleanFilter shared) {
        this.shared = shared;
    }
    
    public BooleanFilter getMypages() {
    	return myPages;
    }
    
    public BooleanFilter myPages() {
    	if (myPages == null) {
    		myPages = new BooleanFilter();
    	}
    	return myPages;
    }
    
    public void setMypages(BooleanFilter myPages) {
    	this.myPages = myPages;
    }

    public InstantFilter getCreatedDate() {
        return createdDate;
    }

    public InstantFilter createdDate() {
        if (createdDate == null) {
            createdDate = new InstantFilter();
        }
        return createdDate;
    }

    public void setCreatedDate(InstantFilter createdDate) {
        this.createdDate = createdDate;
    }

    public StringFilter getCreatedBy() {
        return createdBy;
    }

    public StringFilter createdBy() {
        if (createdBy == null) {
            createdBy = new StringFilter();
        }
        return createdBy;
    }

    public void setCreatedBy(StringFilter createdBy) {
        this.createdBy = createdBy;
    }

    public LongFilter getDashboardComponentId() {
        return dashboardComponentId;
    }

    public LongFilter dashboardComponentId() {
        if (dashboardComponentId == null) {
            dashboardComponentId = new LongFilter();
        }
        return dashboardComponentId;
    }

    public void setDashboardComponentId(LongFilter dashboardComponentId) {
        this.dashboardComponentId = dashboardComponentId;
    }

    public LongFilter getTargetId() {
        return targetId;
    }

    public LongFilter targetId() {
        if (targetId == null) {
            targetId = new LongFilter();
        }
        return targetId;
    }

    public void setTargetId(LongFilter targetId) {
        this.targetId = targetId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final DashboardPageCriteria that = (DashboardPageCriteria) o;
        return (
            Objects.equals(id, that.id) &&
            Objects.equals(name, that.name) &&
            Objects.equals(description, that.description) &&
            Objects.equals(content, that.content) &&
            Objects.equals(note, that.note) &&
            Objects.equals(shared, that.shared) &&
            Objects.equals(createdDate, that.createdDate) &&
            Objects.equals(createdBy, that.createdBy) &&
            Objects.equals(dashboardComponentId, that.dashboardComponentId) &&
            Objects.equals(targetId, that.targetId) &&
            Objects.equals(myPages, that.myPages) 
        );
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, name, description, content, note, shared, createdDate, createdBy, dashboardComponentId, targetId, myPages);
    }

    @Override
    public String toString() {
        return "DashboardPageCriteria{" +
            (id != null ? "id=" + id + ", " : "") +
            (name != null ? "name=" + name + ", " : "") +
            (description != null ? "description=" + description + ", " : "") +
            (content != null ? "content=" + content + ", " : "") +
            (note != null ? "note=" + note + ", " : "") +
            (shared != null ? "shared=" + shared + ", " : "") +
            (createdDate != null ? "createdDate=" + createdDate + ", " : "") +
            (createdBy != null ? "createdBy=" + createdBy + ", " : "") +
            (dashboardComponentId != null ? "dashboardComponentId=" + dashboardComponentId + ", " : "") +
            (targetId != null ? "targetId=" + targetId + ", " : "") +
            (myPages != null ? "myPages=" + myPages + ", " : "") +
            "}";
    }
}
