package it.eng.urbanite.dashboard.service.criteria;

import java.io.Serializable;
import java.util.Objects;

import it.eng.urbanite.dashboard.model.enumeration.TargetType;
import tech.jhipster.service.Criteria;
import tech.jhipster.service.filter.Filter;
import tech.jhipster.service.filter.InstantFilter;
import tech.jhipster.service.filter.LongFilter;
import tech.jhipster.service.filter.StringFilter;

public class TargetAvailableCriteria implements Serializable, Criteria {

    /**
     * Class for filtering TargetType
     */
    public static class TargetTypeFilter extends Filter<TargetType> {

		/**
		 * 
		 */
		private static final long serialVersionUID = 2648384846788760207L;

		public TargetTypeFilter() {}

        public TargetTypeFilter(TargetTypeFilter filter) {
            super(filter);
        }

        @Override
        public TargetTypeFilter copy() {
            return new TargetTypeFilter(this);
        }
    }

    private static final long serialVersionUID = 1L;

    private LongFilter id;
    private TargetTypeFilter type;
    private StringFilter code;
    private StringFilter value;
    private InstantFilter createdDate;
    private StringFilter createdBy;
    
    public TargetAvailableCriteria() {}

    public TargetAvailableCriteria(TargetAvailableCriteria other) {
        this.id = other.id == null ? null : other.id.copy();
        this.type = other.type == null ? null : other.type.copy();
        this.code = other.code == null ? null : other.code.copy();
        this.value = other.value == null ? null : other.value.copy();
        this.createdDate = other.createdDate == null ? null : other.createdDate.copy();
        this.createdBy = other.createdBy == null ? null : other.createdBy.copy();
    }

    @Override
    public TargetAvailableCriteria copy() {
        return new TargetAvailableCriteria(this);
    }

    public LongFilter getId() {
        return id;
    }

    public LongFilter id() {
        if (id == null) {
            id = new LongFilter();
        }
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public TargetTypeFilter getType() {
        return type;
    }

    public TargetTypeFilter type() {
        if (type == null) {
            type = new TargetTypeFilter();
        }
        return type;
    }

    public void setType(TargetTypeFilter type) {
        this.type = type;
    }

    public StringFilter getCode() {
        return code;
    }

    public StringFilter code() {
        if (code == null) {
            code = new StringFilter();
        }
        return code;
    }

    public void setCode(StringFilter code) {
        this.code = code;
    }

    public StringFilter getValue() {
        return value;
    }

    public StringFilter value() {
        if (value == null) {
            value = new StringFilter();
        }
        return value;
    }

    public void setValue(StringFilter value) {
        this.value = value;
    }

    public InstantFilter getCreatedDate() {
        return createdDate;
    }

    public InstantFilter createdDate() {
        if (createdDate == null) {
            createdDate = new InstantFilter();
        }
        return createdDate;
    }

    public void setCreatedDate(InstantFilter createdDate) {
        this.createdDate = createdDate;
    }

    public StringFilter getCreatedBy() {
        return createdBy;
    }

    public StringFilter createdBy() {
        if (createdBy == null) {
            createdBy = new StringFilter();
        }
        return createdBy;
    }

    public void setCreatedBy(StringFilter createdBy) {
        this.createdBy = createdBy;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TargetAvailableCriteria that = (TargetAvailableCriteria) o;
        return (
            Objects.equals(id, that.id) &&
            Objects.equals(type, that.type) &&
            Objects.equals(code, that.code) &&
            Objects.equals(value, that.value) &&
            Objects.equals(createdDate, that.createdDate) &&
            Objects.equals(createdBy, that.createdBy) 
        );
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, type, code, value, createdDate, createdBy);
    }

    @Override
    public String toString() {
        return "TargetAvailableCriteria{" +
            (id != null ? "id=" + id + ", " : "") +
            (type != null ? "type=" + type + ", " : "") +
            (code != null ? "name=" + code + ", " : "") +
            (value != null ? "note=" + value + ", " : "") +
            (createdDate != null ? "createdDate=" + createdDate + ", " : "") +
            (createdBy != null ? "createdBy=" + createdBy + ", " : "") +
            "}";
    }
}
