package it.eng.urbanite.dashboard.service.criteria;

import java.io.Serializable;
import java.util.Objects;

import it.eng.urbanite.dashboard.model.enumeration.TargetType;
import tech.jhipster.service.Criteria;
import tech.jhipster.service.filter.Filter;
import tech.jhipster.service.filter.InstantFilter;
import tech.jhipster.service.filter.LongFilter;
import tech.jhipster.service.filter.StringFilter;

public class TargetCriteria implements Serializable, Criteria {

    /**
     * Class for filtering TargetType
     */
    public static class TargetTypeFilter extends Filter<TargetType> {

        /**
		 * 
		 */
		private static final long serialVersionUID = 2688330347119959170L;

		public TargetTypeFilter() {}

        public TargetTypeFilter(TargetTypeFilter filter) {
            super(filter);
        }

        @Override
        public TargetTypeFilter copy() {
            return new TargetTypeFilter(this);
        }
    }

    private static final long serialVersionUID = 1L;

    private LongFilter id;
    private TargetTypeFilter type;
    private StringFilter name;
    private StringFilter note;
    private InstantFilter createdDate;
    private StringFilter createdBy;
    private LongFilter dashboardPageId;
    
    public TargetCriteria() {}

    public TargetCriteria(TargetCriteria other) {
        this.id = other.id == null ? null : other.id.copy();
        this.type = other.type == null ? null : other.type.copy();
        this.name = other.name == null ? null : other.name.copy();
        this.note = other.note == null ? null : other.note.copy();
        this.createdDate = other.createdDate == null ? null : other.createdDate.copy();
        this.createdBy = other.createdBy == null ? null : other.createdBy.copy();
        this.dashboardPageId = other.dashboardPageId == null ? null : other.dashboardPageId.copy();
    }

    @Override
    public TargetCriteria copy() {
        return new TargetCriteria(this);
    }

    public LongFilter getId() {
        return id;
    }

    public LongFilter id() {
        if (id == null) {
            id = new LongFilter();
        }
        return id;
    }

    public void setId(LongFilter id) {
        this.id = id;
    }

    public TargetTypeFilter getType() {
        return type;
    }

    public TargetTypeFilter type() {
        if (type == null) {
            type = new TargetTypeFilter();
        }
        return type;
    }

    public void setType(TargetTypeFilter type) {
        this.type = type;
    }

    public StringFilter getName() {
        return name;
    }

    public StringFilter name() {
        if (name == null) {
            name = new StringFilter();
        }
        return name;
    }

    public void setName(StringFilter name) {
        this.name = name;
    }

    public StringFilter getNote() {
        return note;
    }

    public StringFilter note() {
        if (note == null) {
            note = new StringFilter();
        }
        return note;
    }

    public void setNote(StringFilter note) {
        this.note = note;
    }

    public InstantFilter getCreatedDate() {
        return createdDate;
    }

    public InstantFilter createdDate() {
        if (createdDate == null) {
            createdDate = new InstantFilter();
        }
        return createdDate;
    }

    public void setCreatedDate(InstantFilter createdDate) {
        this.createdDate = createdDate;
    }

    public StringFilter getCreatedBy() {
        return createdBy;
    }

    public StringFilter createdBy() {
        if (createdBy == null) {
            createdBy = new StringFilter();
        }
        return createdBy;
    }

    public void setCreatedBy(StringFilter createdBy) {
        this.createdBy = createdBy;
    }

    public LongFilter getDashboardPageId() {
        return dashboardPageId;
    }

    public LongFilter dashboardPageId() {
        if (dashboardPageId == null) {
            dashboardPageId = new LongFilter();
        }
        return dashboardPageId;
    }

    public void setDashboardPageId(LongFilter dashboardPageId) {
        this.dashboardPageId = dashboardPageId;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        final TargetCriteria that = (TargetCriteria) o;
        return (
            Objects.equals(id, that.id) &&
            Objects.equals(type, that.type) &&
            Objects.equals(name, that.name) &&
            Objects.equals(note, that.note) &&
            Objects.equals(createdDate, that.createdDate) &&
            Objects.equals(createdBy, that.createdBy) &&
            Objects.equals(dashboardPageId, that.dashboardPageId)
        );
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, type, name, note, createdDate, createdBy, dashboardPageId);
    }

    @Override
    public String toString() {
        return "TargetCriteria{" +
            (id != null ? "id=" + id + ", " : "") +
            (type != null ? "type=" + type + ", " : "") +
            (name != null ? "name=" + name + ", " : "") +
            (note != null ? "note=" + note + ", " : "") +
            (createdDate != null ? "createdDate=" + createdDate + ", " : "") +
            (createdBy != null ? "createdBy=" + createdBy + ", " : "") +
            (dashboardPageId != null ? "dashboardPageId=" + dashboardPageId + ", " : "") +
            "}";
    }
}
