package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;

import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.ComponentType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.DashboardComponent} entity.
 */
@ApiModel(description = "The DashboardComponent entity.")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class DashboardComponentDTO implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Long id;

    @NotNull
    private ComponentType componentType;

    @NotNull
    private String componentName;

    private String componentcontent;

    private String componentPosition;

    private Instant createdDate;

    private String createdBy;

    private DashboardPageDTO dashboardPage;

}
