package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;
import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.MenuType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.DashboardPage} entity.
 */
@ApiModel(description = "The DashboardPage entity.")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class DashboardPageDTO implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private Long id;

    @NotNull
    private String name;

    private String description;

    //@NotNull
    private String content;

    private String note;

    private Boolean shared;
    
    private Instant createdDate;

    private String createdBy;
    
    //ONLY FOR COMODITY
    private Boolean pageOwner;
    private MenuType type;

}
