package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;
import java.util.List;

import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.MenuType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.MenuBlock} entity.
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@ApiModel(description = "The MenuBlock entity.")
public class MenuBlockDTO implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private Long id;

    @NotNull
    private String code;

    @NotNull
    private String label;

    private Integer order;

    @NotNull
    private MenuType type;

    private Instant createdDate;

    private String createdBy;
    private String icon;
    private List<MenuItemDTO> linkedItems;
}
