package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;

import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.MenuType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.MenuItem} entity.
 */
@ApiModel(description = "The MenuItem entity.")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class MenuItemDTO implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 8320107468899796335L;

	private Long id;

    @NotNull
    private String code;

    @NotNull
    private String label;

    private Integer order;

    @NotNull
    private MenuType type;

    private Instant createdDate;

    private String createdBy;

    private String icon;
    
    private DashboardPageDTO dashboardPage;

    private MenuBlockDTO menuBlock;

}
