package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;

import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.TargetType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.TargetAvailable} entity.
 */
@ApiModel(description = "The TargetAvailable entity.")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TargetAvailableDTO implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 7529497018725768978L;

	private Long id;

    @NotNull
    private TargetType type;

    @NotNull
    private String code;

    @NotNull
    private String value;

    private Instant createdDate;

    private String createdBy;
}
