package it.eng.urbanite.dashboard.service.dto;

import java.io.Serializable;
import java.time.Instant;

import javax.validation.constraints.NotNull;

import io.swagger.annotations.ApiModel;
import it.eng.urbanite.dashboard.model.enumeration.TargetType;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * A DTO for the {@link it.eng.urbanite.dashboard.domain.Target} entity.
 */
@ApiModel(description = "The Target entity.")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class TargetDTO implements Serializable {

    /**
	 * 
	 */
	private static final long serialVersionUID = 2738572448128592328L;

	private Long id;

    @NotNull
    private TargetType type;

    @NotNull
    private String name;

    private String note;

    private Instant createdDate;

    private String createdBy;

    private DashboardPageDTO dashboardPage;

}
