package it.eng.urbanite.dashboard.service.mapper;

import it.eng.urbanite.dashboard.model.*;
import it.eng.urbanite.dashboard.service.dto.MenuItemDTO;
import org.mapstruct.*;

/**
 * Mapper for the entity {@link MenuItem} and its DTO {@link MenuItemDTO}.
 */
@Mapper(componentModel = "spring", uses = { DashboardPageMapper.class, MenuBlockMapper.class })
public interface MenuItemMapper extends EntityMapper<MenuItemDTO, MenuItem> {
    @Mapping(target = "dashboardPage", source = "dashboardPage", qualifiedByName = "id")
    @Mapping(target = "menuBlock", source = "menuBlock", qualifiedByName = "id")
    MenuItemDTO toDto(MenuItem s);
}
