package it.eng.urbanite.dashboard.web;

import java.util.Arrays;
import java.util.List;
import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import it.eng.urbanite.dashboard.security.SecurityUtils;


@RestController
@CrossOrigin
@RequestMapping("/app")
public class TestResource {
	private final Logger log = LoggerFactory.getLogger(TestResource.class);
	private final String version = "1.0.0";
	
	@GetMapping("/info")
	public ResponseEntity<List<String>> getInfo() {
		log.info("REST request to get info");
		List<String> list = Arrays.asList("Welcome to the Dashboard Controller v."+version);

		Optional<String> current = SecurityUtils.getCurrentUserLogin();
		log.info("CurrentUserLogin => " + (current.isPresent() ? current.get(): "NULL"));

		List<String> currentAuthorities = SecurityUtils.getCurrentAuthorities();
		for (String auth : currentAuthorities) {
			log.info("CurrentAuthorities => " + auth);
		}

		return ResponseEntity.ok().body(list);
	}

}
